#ifndef HC11SIM_H
#define HC11SIM_H

#include "hc11.h"

typedef enum {None, BriefCase, RugWarriorBootstrap, RugWarriorExpanded} HC11SimConfig;

//////////////////////////////////////////////////////////////////////////////
//
// Class Name: HC11Sim
//
// Author: Kalle Anderson & Jason Buttron
//
// Purpose: This class is used to put the HC11 into various configurations, 
//          like Briefcase or RugWarrior. Later, perhaps it can be used
//          to add memory devices or other things like that. 
//
/////////////////////////////////////////////////////////////////////////////


class HC11Sim
{   
    HC11SimConfig cfg;
    RAM* expanded_ram;
    ROM* briefcase_rom;
 public:    
    
    HC11 hc11; 

    HC11Sim(void);    
    ~HC11Sim(void);    
    void Config(HC11SimConfig ncfg);
    void SetupPsuedoVectors(word_t vector_base_addr);
    void SetStartAddress(Word address);
    bool LoadS19File(const char *fname);
};

#endif