////////////////////////////////////////////////////////////////////////////
//	File:	iosystem.cpp
//
//	Purpose:	Contains the code for the HC11 Timer subsystem
////////////////////////////////////////////////////////////////////////////

#include "hc11.h"
#include "iosystem.h"
#include <stdio.h>

HandshakeIOSubSystem::HandshakeIOSubSystem(HC11 *nhc11)
{
    hc11 = nhc11;
    STRB_pulse=0;
}


void HandshakeIOSubSystem::WriteToPORTB(void)
{
    switch(hc11->regfile.HNDS())
    {
        case 0:
            if(hc11->regfile.INVB())
            {
                hc11->STRB.Output(1);
                STRB_pulse=2;
            }
            else
            {
                hc11->STRB.Output(0);
                STRB_pulse=2;
            }
            break;
        //other modes aren't implemented yet
    }        
};

void HandshakeIOSubSystem::ClockSystem(void)
{     
    switch(hc11->regfile.HNDS())
    {
        case 0:
            if(STRB_pulse>0)
                STRB_pulse--;
            else
            {
                STRB_pulse=0;
                if(hc11->regfile.INVB())                
                    hc11->STRB.Output(0);                
                else
                    hc11->STRB.Output(1);
            }
            break;
        //other modes aren't implemented yet
    }        
};
