// HardCoreWookieDoc.h : interface of the CHardCoreWookieDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_HARDCOREWOOKIEDOC_H__6DC3710B_53BB_11D1_A2C3_0000C0E665E5__INCLUDED_)
#define AFX_HARDCOREWOOKIEDOC_H__6DC3710B_53BB_11D1_A2C3_0000C0E665E5__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "PortIO.h"
#include "hc11view.h"

#include "../emu/hc11sim.h"
#include "../emu/hc11.h"
#include "mainfrm.h"

#include <afxmt.h>

//////////////////////////////////////////////////////////////////////////////
//
// Class Name: CHardCoreWookieDoc
//
// Author: Kalle Anderson
//
// Purpose: Da Document Class. 
//
// Important things it does: It holds the HC11Sim class (and thus the hc11)
//                           "Global" access to the views and stuff.
//                           Manages the thread(s)
//                           Holds the breakpoint and the is_runnning flag
//
/////////////////////////////////////////////////////////////////////////////

// Thread function declaration
UINT TimerProc(LPVOID pParam);

// LoadS19File function declaration
void LoadS19File(char *fname, HC11 *hc11);

class CHardCoreWookieDoc : public CDocument
{
protected: // create from serialization only
	CHardCoreWookieDoc();
	DECLARE_DYNCREATE(CHardCoreWookieDoc)

// Attributes
public:
	CToolBar	m_ToolBar;
//	CCodeView* m_pCodeView;
    CHc11View *m_pHc11View;     
    HWND m_hwndHc11View;
// Operations

    // used when the simulator is run "all out"
    void SimGO(void);
    void SimSTOP(void);

public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHardCoreWookieDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	//}}AFX_VIRTUAL

// Implementation
public:
    // da break point. (set negative to disable)
    int m_breakpoint;
	
    // The event used to pause the worker thread
    HANDLE m_hThreadGo;    

    // signifies that the thread is running
	int m_isrunning;    	
	// editing??
	CString asmfile;
        
    // THE SIMULATOR
	HC11Sim hc11sim;

    HC11* GetHC11();

	virtual ~CHardCoreWookieDoc();

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

// Generated message map functions
public:

    //{{AFX_MSG(CHardCoreWookieDoc)
	afx_msg void OnSimmulatorStep();
	afx_msg void OnUpdateSimmulatorStep(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileOpen(CCmdUI* pCmdUI);
	afx_msg void OnAddRmbs();
	afx_msg void OnUpdateAddRmbs(CCmdUI* pCmdUI);
	afx_msg void OnEgg();
	afx_msg void OnUpdateClose(CCmdUI* pCmdUI);
	afx_msg void OnClose();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
    // The worker thread (i dunno why it got called m_timerThread
	CWinThread* m_timerThread;    	
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HARDCOREWOOKIEDOC_H__6DC3710B_53BB_11D1_A2C3_0000C0E665E5__INCLUDED_)
